/*
Copyright 2019 caicloud authors. All rights reserved.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/caicloud/cyclone/pkg/apis/cyclone/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeExecutionClusters implements ExecutionClusterInterface
type FakeExecutionClusters struct {
	Fake *FakeCycloneV1alpha1
}

var executionclustersResource = schema.GroupVersionResource{Group: "cyclone.dev", Version: "v1alpha1", Resource: "executionclusters"}

var executionclustersKind = schema.GroupVersionKind{Group: "cyclone.dev", Version: "v1alpha1", Kind: "ExecutionCluster"}

// Get takes name of the executionCluster, and returns the corresponding executionCluster object, and an error if there is any.
func (c *FakeExecutionClusters) Get(name string, options v1.GetOptions) (result *v1alpha1.ExecutionCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(executionclustersResource, name), &v1alpha1.ExecutionCluster{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ExecutionCluster), err
}

// List takes label and field selectors, and returns the list of ExecutionClusters that match those selectors.
func (c *FakeExecutionClusters) List(opts v1.ListOptions) (result *v1alpha1.ExecutionClusterList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(executionclustersResource, executionclustersKind, opts), &v1alpha1.ExecutionClusterList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.ExecutionClusterList{}
	for _, item := range obj.(*v1alpha1.ExecutionClusterList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested executionClusters.
func (c *FakeExecutionClusters) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(executionclustersResource, opts))
}

// Create takes the representation of a executionCluster and creates it.  Returns the server's representation of the executionCluster, and an error, if there is any.
func (c *FakeExecutionClusters) Create(executionCluster *v1alpha1.ExecutionCluster) (result *v1alpha1.ExecutionCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(executionclustersResource, executionCluster), &v1alpha1.ExecutionCluster{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ExecutionCluster), err
}

// Update takes the representation of a executionCluster and updates it. Returns the server's representation of the executionCluster, and an error, if there is any.
func (c *FakeExecutionClusters) Update(executionCluster *v1alpha1.ExecutionCluster) (result *v1alpha1.ExecutionCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(executionclustersResource, executionCluster), &v1alpha1.ExecutionCluster{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ExecutionCluster), err
}

// Delete takes name of the executionCluster and deletes it. Returns an error if one occurs.
func (c *FakeExecutionClusters) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(executionclustersResource, name), &v1alpha1.ExecutionCluster{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeExecutionClusters) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(executionclustersResource, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.ExecutionClusterList{})
	return err
}

// Patch applies the patch and returns the patched executionCluster.
func (c *FakeExecutionClusters) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ExecutionCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(executionclustersResource, name, data, subresources...), &v1alpha1.ExecutionCluster{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ExecutionCluster), err
}
